<template>
    <div class="login">
        <div class="login__form">
            <h3>Вхід</h3>
            <form @submit.prevent="loginUser" class="form">
                <div class="form__group" :class="{ form__hasError: !!errorMessage }">
                    <label for="login">Логін</label>
                    <input id="login" v-model="login" type="text" placeholder="Email або номер телефону" @focus="errorMessage=''">
                </div>
                <div v-if="!!errorMessage" class="form__errors">{{ errorMessage }}</div>
                <div class="form__group">
                    <label for="password">Пароль</label>
                    <div class="form__password">
                        <input id="password" v-model="password" :type=passwordType @focus="errorMessage=''">
                        <button type="button" @click="showPassword=!showPassword">
                            <svg v-if="showPassword" width="18" height="18" viewBox="0 0 18 18" fill="none" xmlns="http://www.w3.org/2000/svg">
                                <path d="M8.86328 6.14923L11.44 8.72592L11.4522 8.59095C11.4522 7.23715 10.352 6.13696 8.99825 6.13696L8.86328 6.14923Z" fill="#3F3F3F" fill-opacity="0.5"/>
                                <path d="M8.99795 4.50103C11.2556 4.50103 13.088 6.33336 13.088 8.59102C13.088 9.11863 12.9816 9.6217 12.7976 10.0839L15.1902 12.4765C16.4254 11.4458 17.3988 10.1125 18 8.59102C16.5808 5.00003 13.0921 2.45605 8.99799 2.45605C7.85278 2.45605 6.75669 2.66054 5.73828 3.02864L7.50516 4.79141C7.96727 4.61146 8.47034 4.50103 8.99795 4.50103Z" fill="#3F3F3F" fill-opacity="0.5"/>
                                <path d="M0.817983 2.27195L2.68301 4.13698L3.05521 4.50918C1.70552 5.56439 0.638037 6.96727 0 8.59097C1.41515 12.182 4.90798 14.7259 8.99797 14.7259C10.2659 14.7259 11.4765 14.4805 12.5849 14.0347L12.9326 14.3824L15.317 16.7709L16.36 15.7321L1.86093 1.229L0.817983 2.27195ZM5.34153 6.79139L6.60533 8.05519C6.56852 8.23107 6.54398 8.40692 6.54398 8.59097C6.54398 9.94476 7.64417 11.045 8.99797 11.045C9.18202 11.045 9.3579 11.0204 9.52968 10.9836L10.7935 12.2474C10.2495 12.5173 9.64421 12.681 8.99797 12.681C6.7403 12.681 4.90798 10.8486 4.90798 8.59097C4.90798 7.94476 5.07159 7.33943 5.34153 6.79139Z" fill="#3F3F3F" fill-opacity="0.5"/>
                            </svg>
                            <svg v-else width="18" height="18" viewBox="0 0 18 18" fill="none" xmlns="http://www.w3.org/2000/svg">
                                <g clip-path="url(#clip0)">
                                    <path d="M8.99751 6.54553C7.64341 6.54553 6.54297 7.64597 6.54297 9.00007C6.54297 10.3542 7.64341 11.4546 8.99751 11.4546C10.3516 11.4546 11.452 10.3542 11.452 9.00007C11.452 7.64597 10.3516 6.54553 8.99751 6.54553Z" fill="#80EA47"/>
                                    <path d="M9.00002 2.86365C4.90909 2.86365 1.41547 5.40817 0 9.00002C1.41547 12.5918 4.90909 15.1364 9.00002 15.1364C13.095 15.1364 16.5846 12.5918 18 9.00002C16.5846 5.40817 13.095 2.86365 9.00002 2.86365ZM9.00002 13.0909C6.74184 13.0909 4.90909 11.2582 4.90909 8.99998C4.90909 6.74179 6.74184 4.90909 9.00002 4.90909C11.2582 4.90909 13.0909 6.74183 13.0909 9.00002C13.0909 11.2582 11.2582 13.0909 9.00002 13.0909Z" fill="#80EA47"/>
                                </g>
                                <defs>
                                    <clipPath id="clip0">
                                        <rect width="18" height="18" fill="white"/>
                                    </clipPath>
                                </defs>
                            </svg>
                        </button>
                    </div>
                </div>
                <div class="form__group">
                    <label class="form__checkbox">Запам'ятати мене
                        <input v-model="isRemember" type="checkbox" checked="checked">
                        <span class="checkmark"></span>
                    </label>
                </div>
                <button type="submit" class="form__submitBtn">
                    Вхід
                </button>
            </form>
        </div>
        <div class="login__logo">
            <img alt="Logo" src="../assets/logo.png">
        </div>
    </div>
</template>

<script>
    import { login } from "../services/checkAccess";

    export default {
        name: 'Login',

        data() {
            return {
                login: '',
                password: '',
                showPassword: false,
                isRemember: false,
                errorMessage: ''
            }
        },

        computed: {
            passwordType() {
                return this.showPassword ? 'text' : 'password';
            }
        },

        methods: {
            async loginUser() {
                const isValid = this.validateUserData(this.login);

                if (isValid) {
                    await login(this.login, this.password)
                        .then(userSession => {
                            if (userSession) {
                                this.$router.push({ name: 'Admin'});
                            } else {
                                this.errorMessage = '*Перевірте логін та пароль';
                            }
                        });
                } else {
                    this.errorMessage = '*Введіть коректну пошту або телефон ';
                }
            },

            validateUserData(login) {
                const regExpEmail = /\S+@\S+\.\S+/;
                const regExpPhone = /^\d{10}$/;

                return regExpEmail.test(login) || regExpPhone.test(login);
            }
        }
    }
</script>

<style lang="scss" scoped>
    .login {
        width: 100%;
        min-height: 100vh;
        display: flex;
        justify-content: center;
        align-items: center;
        position: relative;
        background-image: linear-gradient(0deg, rgba(63, 63, 63, 0.7), rgba(63, 63, 63, 0.7)), url("../assets/login_bckg_min.jpg");
        background-repeat: no-repeat;
        background-position: center center;
        background-attachment: fixed;
        background-size: cover;

        &__form {
            padding: 45px;
            background: #FFFFFF;

            h3 {
                font-size: 2em;
                margin-bottom: 45px;
            }

            label {
                margin-bottom: 12px;
                font-size: 0.8em;
                opacity: 0.7;
            }

            input:not([type=checkbox]) {
                width: 100%;
                max-width: 250px;
                padding: 15px;
                color: #434343;
                font-size: 0.88em;
                border-radius: 13px;
                border: 1px solid rgba(63, 63, 63, 0.08);
            }
        }

        &__logo {
            position: absolute;
            top: 0%;
            left: 0%;
        }
    }

    .form {
        &__group {
            margin-bottom: 12px;
        }

        &__hasError {
            margin-bottom: 0px;
        }

        &__errors {
            color: #FF0000;
            font-size: 0.7em;
            height: 12px;
        }

        &__password {
            position: relative;

            button {
                position: absolute;
                height: 18px;
                top: 50%;
                right: 5%;
                transform: translate(0, -50%);
            }
        }

        &__checkbox {
            display: flex;
            align-items: center;
            position: relative;
            padding-left: 35px;
            margin-bottom: 12px;
            cursor: pointer;
            font-size: 22px;
            user-select: none;
            height: 24px;

            input {
                position: absolute;
                opacity: 0;
                cursor: pointer;
                height: 0;
                width: 0;
            }

            .checkmark {
                position: absolute;
                top: 0;
                left: 0;
                height: 24px;
                width: 24px;
                border: 1px solid #434343;
                border-radius: 3px;
            }

            input:checked ~ .checkmark {
                border: none;
                background: linear-gradient(90deg, #80EA47 0%, #9CEA72 100%);
            }

            input:checked ~ .checkmark:after {
                display: block;
            }

            .checkmark:after {
                content: "";
                position: absolute;
                display: none;
                left: 9px;
                top: 4px;
                width: 5px;
                height: 10px;
                border: solid white;
                border-width: 0 3px 3px 0;
                -webkit-transform: rotate(45deg);
                -ms-transform: rotate(45deg);
                transform: rotate(45deg);
            }
        }

        &__submitBtn {
            width: 100%;
            background: linear-gradient(90deg, #80EA47 0%, #9CEA72 100%);
            box-shadow: 0px 10px 15px rgba(51, 138, 5, 0.1);
            border-radius: 13px;
            font-weight: 500;
            font-size: 0.78em;
            color: #FFFFFF;
            line-height: 16px;
            padding: 16px;
            margin-top: 18px;
        }
    }
</style>
